clear all;
clc;
close all;

%% UCA settings
Nt = 401;
fc = 30e9;
c = 3e8;
lambda = c/fc;
d = lambda/2;

num_r = 200000;
r_list = linspace(0, 20, num_r);
g_r = zeros(1, num_r);
for idx_r = 1:num_r
    r_iter = r_list(idx_r);
    g_r(idx_r) = abs(besselj(0, r_iter));
end

C = linspecer(9);
figure;
plot(r_list, g_r,'LineWidth',1.5,'color', C(2,:));
xlabel('\beta','FontSize',13);
ylabel('|J_0(\beta)|','FontSize',13);
grid on;
box on;