function [H] = cylindrical_far_beam(fc, Nt, M, r_radius, d, theta_list, phi_list)

c = 3e8;
lambda = c/fc;
[~, d_len] = size(theta_list);

%% UCA settings
pp = 1:1:Nt;
phi_p = (pp-1)*2*pi/Nt;

mm = (-(M-1)/2:1:(M-1)/2).';

%% channel generation
H = zeros(d_len, Nt*M);
for i_d = 1:d_len
    theta0 = theta_list(i_d);
    phi0 = phi_list(i_d);
    
    dis_matrix = -r_radius*sin(theta0)*cos(phi0-phi_p)-mm*d*cos(theta0);
    at = exp(-1j*2*pi/lambda*dis_matrix)/sqrt(Nt*M);
    H(i_d, :) = reshape(at,[],1);
end

end
