function [H, H_app] = cylindrical_near_beam(fc, Nt, M, r_radius, d, r_list, theta_list, phi_list)

c = 3e8;
lambda = c/fc;
[~, d_len] = size(theta_list);

%% array settings
pp = 1:1:Nt;
phi_p = (pp-1)*2*pi/Nt;
mm = (-(M-1)/2:1:(M-1)/2).';

%% channel generation
H = zeros(d_len, Nt*M);
H_app = zeros(d_len, Nt*M);
for i_d = 1:d_len
    r0 = r_list(i_d);
    theta0 = theta_list(i_d);
    phi0 = phi_list(i_d);
    
    item1 = -r_radius*sin(theta0)*cos(phi0-phi_p);
    item2 = -mm*d*cos(theta0);
    item3 = r_radius^2/2/r0*(1-sin(theta0).^2*cos(phi0-phi_p).^2);
    item4 = mm.^2*d^2/2/r0*(1-cos(theta0)^2);
    item5 = -r_radius*d/r0*mm*sin(theta0)*cos(theta0)*cos(phi0-phi_p);
    
    dis_matrix = -r_radius*sin(theta0)*cos(phi0-phi_p)-mm*d*cos(theta0)...
        +r_radius^2/2/r0*(1-sin(theta0).^2*cos(phi0-phi_p).^2)+mm.^2*d^2/2/r0*(1-cos(theta0)^2)...
        -r_radius*d/r0*mm*sin(theta0)*cos(theta0)*cos(phi0-phi_p);
    at = exp(-1j*2*pi/lambda*dis_matrix)/sqrt(Nt*M);
    H(i_d, :) = reshape(at,[],1);

    dis_matrix_app = -r_radius*sin(theta0)*cos(phi0-phi_p)-mm*d*cos(theta0)...
        +r_radius^2/2/r0*(1-sin(theta0).^2*cos(phi0-phi_p).^2)+mm.^2*d^2/2/r0*(1-cos(theta0)^2);
    at_app = exp(-1j*2*pi/lambda*dis_matrix_app)/sqrt(Nt*M);
    H_app(i_d, :) = reshape(at_app,[],1);
end

end
